'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasDecoractor = hasDecoractor;
exports.parse = parse;

var _babelTypes = require('babel-types');

var types = _interopRequireWildcard(_babelTypes);

var _metaData = require('../model/metaData');

var _metaData2 = _interopRequireDefault(_metaData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function hasDecoractor(path, name) {
  return (path.node.decorators || []).filter(function (decorator) {
    return decorator.expression.name.toLowerCase() === name.toLowerCase();
  }).length > 0;
};

function parse(_ref) {
  var node = _ref.node;

  var config = {};
  if (node.decorators) {
    node.decorators.filter(function (decorator) {
      var type = decorator.expression.type;
      if (type === 'Identifier' && decorator.expression.name.toLowerCase() === 'style') {
        config.style = true;
      } else if (type === 'CallExpression' && decorator.expression.callee.name.toLowerCase() === 'lang') {
        config.lang = decorator.expression.arguments;
      } else if (type === 'CallExpression' && decorator.expression.callee.name.toLowerCase() === 'mixins') {
        config.mixins = decorator.expression.arguments;
      } else if (type === 'CallExpression' && decorator.expression.callee.name.toLowerCase() === 'namespace') {
        config.namespace = decorator.expression.arguments;
      }
    });
  }

  return new _metaData2['default'](config);
};