'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports['default'] = function () {
  var requires = [];
  var inProgess = false;

  return {
    // This plugin add easy access to the class properties
    inherits: require("babel-plugin-syntax-class-properties"),
    visitor: {
      ExportNamedDeclaration: function (path) {
        if (inProgess) {
          return;
        }
        inProgess = true;
        // We dont want any export declaration.
        path.remove();
        inProgess = false;
      },
      FunctionDeclaration: function (path) {
        if (inProgess) {
          return;
        }
        inProgess = true;
        var node = path.node;
        // This is a controller.

        if (node.id.name === 'render') {
          path.parentPath.replaceWith((0, _engine.use)(node.body.body, requires));
        }
        inProgess = false;
      },
      Class: function (path) {
        var innerBody = [];
        var staticBody = [];
        var attributes = [];
        var body = path.get('body');
        var ref = void 0;
        var metaData = void 0;
        var superClassName = 'Y.Base';

        if (inProgess) {
          return;
        }

        inProgess = true;
        if (path.get('superClass') && path.get('superClass').node) {
          if (types.isMemberExpression(path.get('superClass').node)) {
            var memberExpression = path.get('superClass').node;
            superClassName = member.toString(memberExpression.object, memberExpression.property);
          } else {
            superClassName = path.get('superClass').node.name;
          }
        }

        // Get the class reference.
        if (path.isClassExpression() || !path.node.id) {
          ref = path.scope.generateUidIdentifier('class');
        } else {
          ref = path.node.id;
        }

        metaData = (0, _decorators.parse)(path);

        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = body.get('body')[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var node = _step.value;

            var result = void 0;

            if ((0, _decorators.hasDecoractor)(node, 'attribute')) {
              attributes.push((0, _classProperty2['default'])(node));
              node.remove();
            } else if (node.isClassProperty()) {
              result = (0, _classProperty2['default'])(node);
            } else if (node.isClassMethod({ kind: 'constructor' })) {
              result = (0, _classMethod2['default'])(node, types.identifier('initializer'));
              innerBody.push(result);
              node.remove();
            } else if (node.isClassMethod()) {
              result = (0, _classMethod2['default'])(node);
            }

            if (node.node) {
              if (node.node['static']) {
                staticBody.push(result);
              } else {
                innerBody.push(result);
              }
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator['return']) {
              _iterator['return']();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        staticBody.push(types.objectProperty(types.identifier('ATTRS'), types.objectExpression(attributes)));

        path.replaceWith((0, _engine.add)(ref.name, superClassName, types.objectExpression(innerBody), types.objectExpression(staticBody), metaData, requires));

        inProgess = false;
      },

      Program: {
        enter: function (path) {
          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = undefined;

          try {
            for (var _iterator2 = path.get('body')[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var _path = _step2.value;

              // Finds all the imports
              if (_path.isImportDeclaration()) {
                requires.push(types.stringLiteral(_path.node.source.value));
                //  modules.push(t.stringLiteral(path.node.specifiers[0].local.name));
                _path.remove();
              }
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2['return']) {
                _iterator2['return']();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }
        },
        exit: function (path) {
          requires = [];
        }
      }
    }
  };
};

var _babelTypes = require('babel-types');

var types = _interopRequireWildcard(_babelTypes);

var _classProperty = require('./processors/classProperty');

var _classProperty2 = _interopRequireDefault(_classProperty);

var _classMethod = require('./processors/classMethod');

var _classMethod2 = _interopRequireDefault(_classMethod);

var _decorators = require('./helpers/decorators');

var _memberExpressions = require('./helpers/memberExpressions');

var member = _interopRequireWildcard(_memberExpressions);

var _engine = require('./templates/engine');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }