'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.add = add;
exports.use = use;

var _babelTemplate = require('babel-template');

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

var _babelTypes = require('babel-types');

var types = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Template_literals
var addTemplate = (0, _babelTemplate2['default'])('\n  YUI.add(MODULE_NAME_STRING, function(Y) {\n    Y.namespace(MODULE_NS).MODULE_NAME = Y.Base.create(MODULE_NAME_STRING, MODULE_BASE, MODULE_MIXINS,\n      MODULE_BODY,\n      STATIC_BODY\n    );\n  }, \'1.0.0\', {\n    \'requires\': MODULE_REQUIRES,\n    \'lang\': MODULE_LANG,\n    \'skinnable\': HAS_SKIN\n  });\n');

var useTemplate = (0, _babelTemplate2['default'])('\n  YUI().use(MODULE_REQUIRES, function(Y) {\n    MODULE_BODY\n  });\n');

function add(id, superClassName, body, staticBody, metaData, requires) {
  return addTemplate({
    MODULE_NAME: types.identifier(id),
    MODULE_NAME_STRING: types.stringLiteral(id),
    MODULE_BASE: types.identifier(superClassName),
    MODULE_BODY: body,
    MODULE_REQUIRES: types.arrayExpression(requires),
    MODULE_LANG: metaData.lang,
    HAS_SKIN: types.booleanLiteral(metaData.style),
    MODULE_MIXINS: metaData.mixins,
    MODULE_NS: metaData.namespace,
    STATIC_BODY: staticBody
  });
};

function use(body, requires) {
  return useTemplate({
    MODULE_BODY: body,
    MODULE_REQUIRES: types.arrayExpression(requires)
  });
};